# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTIBILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

bl_info = {
    "name" : "Procedural Coating Effect",
    "author" : "CGBlender", 
    "description" : "Procedural Coating Effect",
    "blender" : (3, 5, 0),
    "version" : (1, 1, 0),
    "location" : "",
    "warning" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "3D View" 
}


import bpy
import bpy.utils.previews
import os


addon_keymaps = {}
_icons = None
class SNA_PT_PROCEDURAL_COATING_EFFECT_59FF1(bpy.types.Panel):
    bl_label = 'Procedural Coating Effect'
    bl_idname = 'SNA_PT_PROCEDURAL_COATING_EFFECT_59FF1'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'PCE'
    bl_order = 0
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        op = layout.operator('sna.procedural_coating_effect_3e6d5', text='Apply Coating Effect', icon_value=0, emboss=True, depress=False)
        col_7409B = layout.column(heading='', align=False)
        col_7409B.alert = False
        col_7409B.enabled = True
        col_7409B.active = True
        col_7409B.use_property_split = False
        col_7409B.use_property_decorate = False
        col_7409B.scale_x = 1.0
        col_7409B.scale_y = 1.0
        col_7409B.alignment = 'Expand'.upper()
        col_7409B.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        col_7409B.label(text='Chose Empty From Scene', icon_value=0)
        col_7409B.prop(bpy.context.active_object.modifiers.active.node_group.nodes['Object Info'].inputs[0], 'default_value', text='Active Empty', icon_value=0, emboss=True)
        col_7409B.prop(bpy.context.active_object.modifiers.active.node_group.nodes['Set Material'].inputs[2], 'default_value', text='Coating Material', icon_value=0, emboss=True)
        col_7409B.prop(bpy.context.active_object.modifiers.active.node_group.nodes['Math.004'].inputs[1], 'default_value', text='Coating Width', icon_value=0, emboss=True)
        col_7409B.prop(bpy.context.active_object.modifiers.active.node_group.nodes['Mix'].inputs[0], 'default_value', text='Coating Factor', icon_value=0, emboss=True)
        col_7409B.prop(bpy.context.active_object.modifiers.active.node_group.nodes['Distribute Points on Faces'].inputs[3], 'default_value', text='Coating Density', icon_value=0, emboss=True)
        col_7409B.prop(bpy.context.active_object.modifiers.active.node_group.nodes['Noise Texture'].inputs[2], 'default_value', text='Coating Detail', icon_value=0, emboss=True)
        col_7409B.prop(bpy.context.active_object.modifiers.active.node_group.nodes['Noise Texture'].inputs[3], 'default_value', text='Coating D2', icon_value=0, emboss=True)
        col_7409B.prop(bpy.context.active_object.modifiers.active.node_group.nodes['Noise Texture'].inputs[4], 'default_value', text='Coating DR', icon_value=0, emboss=True)
        col_7409B.prop(bpy.context.active_object.modifiers.active.node_group.nodes['Noise Texture'].inputs[5], 'default_value', text='Coating DL', icon_value=0, emboss=True)
        col_7409B.prop(bpy.context.active_object.modifiers.active.node_group.nodes['Noise Texture'].inputs[8], 'default_value', text='Coating DD', icon_value=0, emboss=True)


class SNA_OT_Procedural_Coating_Effect_3E6D5(bpy.types.Operator):
    bl_idname = "sna.procedural_coating_effect_3e6d5"
    bl_label = "Procedural Coating Effect"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and False:
            cls.poll_message_set()
        return not False

    def execute(self, context):
        bpy.ops.object.modifier_add('INVOKE_DEFAULT', type='NODES')
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'Coating Effect1.blend') + r'\NodeTree', filename='Procedural Coating Effect', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_9B0EF = None if not new_data else new_data[0]
        bpy.context.active_object.modifiers.active.node_group = bpy.data.node_groups['Procedural Coating Effect']
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def register():
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.utils.register_class(SNA_PT_PROCEDURAL_COATING_EFFECT_59FF1)
    bpy.utils.register_class(SNA_OT_Procedural_Coating_Effect_3E6D5)


def unregister():
    global _icons
    bpy.utils.previews.remove(_icons)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    bpy.utils.unregister_class(SNA_PT_PROCEDURAL_COATING_EFFECT_59FF1)
    bpy.utils.unregister_class(SNA_OT_Procedural_Coating_Effect_3E6D5)
